;; Copyright (c) 1996 Oscar Waddell
;;
;; See the file "Notice" for information on usage and redistribution
;; of this file, and for a DISCLAIMER OF ALL WARRANTIES.

(define-syntax define-generics-module
  (syntax-rules ()
    [(_ modulename (generic ...))
     (module modulename (generic ...)
       (define-generic generic)
       ...)]))

(define-generics-module swl:generics
(
class-name
y->index
set-window-pos!
set-window-size!
word-start
line-start
word-end
line-end
print
activate
add-offset
adopt
swl:apply-callback-proc
apply-markup
bounding-box
clear-selection
configure
cursor-bof?
cursor-bol
cursor-bol?
cursor-eof?
cursor-eol
cursor-eol?
deactivate
delete
delete-all
delete-char
delete-eol
delete-selection-at-cursor
deselect
destroy
disown
ensure-configured-for
find-closest
find-enclosed
find-item
find-overlapping
fixed-mark
flash
floating-mark
focus-next
focus-prev
get-above-paragraph-space
get-accept-focus
get-action
get-active-background-color
get-active-foreground-color
get-anchor
get-arrow-shape
get-arrow-style
get-background-color
get-below-paragraph-space
get-blank
get-border-width
get-cap-style
get-char
get-close-enough
get-confine
get-coords
get-cursor-pos
get-digits
get-disabled-foreground-color
get-draw-indicator
get-draw-spline
get-enabled
get-export-selection
get-extent
get-fill-color
get-font
get-foreground-color
get-min
get-grid
get-height
get-height/char
get-horizontal-view
get-hpad
get-hscroll-increment
get-hscroll-notify
get-icon-title
get-image
get-insert-border-width
get-insert-color
get-insert-off-time
get-insert-on-time
get-insert-width
get-item
get-items
get-join-style
get-jump-scroll
get-justify
get-key-press-method
get-key-release-method
get-left-margin
get-length
get-line-space
get-line-thickness
get-menu
get-mouse-cursor
get-mouse-enter-method
get-mouse-leave-method
get-mouse-motion-method
get-mouse-press-method
get-mouse-release-method
get-orientation
get-outline-color
get-overstrike
get-paragraph-indent
get-parent
get-relief
get-repeat-delay
get-repeat-interval
get-resolution
get-right-margin
get-root-x
get-root-y
get-scroll-region
get-select-background-color
get-select-border-width
get-select-color
get-select-foreground-color
get-select-image
get-select-mode
get-selected-string
get-show-value
get-skip-increment
get-slider-length
get-spline-steps
get-start
get-stipple
get-string
get-style
get-tabs
get-title
get-max
get-traversal-background-color
get-traversal-color
get-traversal-thickness
get-trough-color
get-underline
get-underline-index
get-value
get-vertical-view
get-view
get-vpad
get-vscroll-increment
get-vscroll-notify
get-width
get-width/char
get-window
get-wrap
get-wrap-length
hide
hide-cascade
hscroll
iconify
index-of
init
insert
insert-at
insert-widget-at
invoke
item-count
item-enabled?
key-press
key-release
lower
make-visible
mark-exists?
mark-name
marked-ranges
markups-at
mouse-enter
mouse-leave
mouse-motion
mouse-press
mouse-release
move
move-char
move-line
move-to-left
move-to-top
move-word
pos<=?
pos<?
pos=?
pos>=?
pos>?
postscript
raise
remove-markup
rgb-blue
rgb-green
rgb-red
rgb-values
scheme->tcl
screen->canvas-x
screen->canvas-y
search
select
select-adjust
select-from
select-range
select-to
get-selected-items
selected?
selection-exists?
set-above-paragraph-space!
set-accept-focus!
set-transient!
get-transient
set-action!
set-active-background-color!
set-active-foreground-color!
set-anchor!
set-arrow-shape!
set-arrow-style!
set-background-color!
set-below-paragraph-space!
set-blank!
set-border-width!
set-cap-style!
set-close-enough!
set-confine!
set-coords!
set-cursor-pos!
set-digits!
set-disabled-foreground-color!
set-draw-indicator!
set-draw-spline!
set-enabled!
set-export-selection!
set-extent!
set-fill-color!
set-focus
set-font!
set-foreground-color!
set-min!
set-grid!
set-height!
set-height/char!
set-hpad!
set-hscroll-increment!
set-hscroll-notify!
set-icon-title!
set-image!
set-insert-border-width!
set-insert-color!
set-insert-off-time!
set-insert-on-time!
set-insert-width!
set-join-style!
set-jump-scroll!
set-justify!
set-key-press-method!
set-key-release-method!
set-left-margin!
set-length!
set-line-space!
set-line-thickness!
set-menu!
set-mouse-cursor!
set-mouse-enter-method!
set-mouse-leave-method!
set-mouse-motion-method!
set-mouse-press-method!
set-mouse-release-method!
set-orientation!
set-outline-color!
set-overstrike!
set-paragraph-indent!
set-parent!
set-relief!
set-repeat-delay!
set-repeat-interval!
set-resolution!
set-right-margin!
set-scroll-region!
set-select-background-color!
set-select-border-width!
set-select-color!
set-select-foreground-color!
set-select-image!
set-select-mode!
set-show-value!
set-skip-increment!
set-slider-length!
set-spline-steps!
set-start!
set-stipple!
set-style!
set-tabs!
set-title!
set-max!
set-traversal-background-color!
set-traversal-color!
set-traversal-thickness!
set-trough-color!
set-underline!
set-underline-index!
set-value!
set-view!
set-vpad!
set-vscroll-increment!
set-vscroll-notify!
set-width!
set-width/char!
set-window!
set-wrap!
set-wrap-length!
show
show-cascade
toggle
visible?
vscroll
x->index
xy->index
y->item
y-position
)
)

(eval-when (compile)
(import swl:generics)
)
